##########################################################################
# JeggLink.tcl  Goes with JeggLink.class  v1.3                           #
#                                                                        #
# By Pierre-Mikael Legris plegris@fbwww.epfl.ch                          #
# 24 May 98                                                              #
# This script was tested only on 1.3.14 version of eggdrop               #
##########################################################################
# Now JeggLink support multiple channels.
# The number you set for each channel must be the same than the one
# on the JeggLink.html page on the line <param name="CHAT" value="1"> 
# where "1" is the number to change for each channel
# 
# note for botnets:
# If your bot is running on a botnet with others JeggLinks be sure to set 
# differents values for Pchannel(X) and <param name="CHAT" value="X"> 

#for the folowing parameters to set, the "(#)" represent each channel
#so if you have to Pchannel() you must have two DTopic() and URLJ() 
#add as many Pchannel() as you need

# !! even if you don't plan to run a JeggLink on each of your Channel please
#    add them to the list to avoid anying error messages

## Set the Name of the channel(s) were the eggdrop is
## !!!!! use low case!! or it won't work !!!! 
set Pchannel(1) "#jegg"
# set Pchannel(2) "#jegg2"

## Set the Default topic of this channel
set DTopic(1) "JeggLink Channel"
# set DTopic(2) "JeggLink Channel 2"

## Set the URL of your page JeggLink
set URLJ(1) "http://fbwww.epfl.ch/~plegris/Jegg"
# set URLJ(2) "http://www.jegg.org"


############ NOTHING NEED TO BE EDITED BELOW THIS LINE ###################

### line added thanx to Dennis Roos <d.roos@tip.nl> to avoid the anoying
# Pchat bug
set Pchannel(0) ""

### create the oposite of Pchannel
set id [array startsearch Pchannel]
while {[array anymore Pchannel $id]} {
    set value [array nextelement Pchannel $id] 
    set Pchat($Pchannel($value)) $value
}

### clean Uidx
for {set i 0} { $i < 100 } { incr i} {
    set Uidx($i) ""
}

### handle actions from IRC
bind ctcp - "ACTION" cact
proc cact {nick uhost handle channel key text} {
    global Pchat
    dccputchan $Pchat([string tolower $channel]) "ACT $nick $text"
}

### handle actions from the web
### text = <#chat> <message>
bind dcc - wact w_act
proc w_act {handle idx text} {
    global Pchannel
    set chan [lindex $text 0] 
    set msg [lrange $text 1 end] 
    putserv "PRIVMSG $Pchannel($chan) :*[lrange $text 1 end]"
    dccputchan $chan "ACT $msg"
}


### handle chat from the web
bind chat - * forward
proc forward {nick chan text} {
    global Pchannel 
    if {($Pchannel($chan) != "" )} { # if it's a supported chat channel
	putserv "PRIVMSG $Pchannel($chan) :<[lindex $text 2]> [lrange $text 3 end]"
    }
}


### handle what's said in the channel
bind pubm - * repeat
proc repeat {nick uhost handle channel text} {
    global botnick Pchat
    if { $nick != $botnick } {
	dccputchan $Pchat([string tolower $channel]) "SAY $nick $text"
    }
}

### handle joins
bind join - * ujoin
proc ujoin {nick uhost handle channel} {
    global botnick Pchat
    if { $nick == $botnick } {
	nuli $channel
    } else {
	dccputchan $Pchat([string tolower $channel]) "JOI $nick $uhost"
    }
}

### handle parts on IRC
bind part - * upart
proc upart {nick uhost handle channel} {
    global botnick Pchat
    if { $nick == $botnick } {
	nuli $channel
    } else {
	dccputchan $Pchat([string tolower $channel]) "PAR $nick"
    }
}

### handle kicks on IRC
bind kick - * ukick
proc ukick {nick uhost handle channel knick reason} {
    global Pchat
    dccputchan $Pchat([string tolower $channel]) "PAR $knick"
}

### sign off on IRC
bind sign - * usign
proc usign {nick uhost handle channel reason} {
    global Pchat
    dccputchan $Pchat([string tolower $channel]) "PAR $nick"
}

### user changes nick on IRC
bind nick - * cnick
proc cnick {nick uhost handle channel newnick} {
    global Pchat
    dccputchan $Pchat([string tolower $channel]) "NIC $nick $newnick"
}

### gives the userlist from an IRC msg
bind msg o !who RCwww
proc RCwww {nick uhost handle text} { Cwww $nick $uhost $handle [lindex $text 0] [lrange $text 1 end]}



### kick from IRC msg
bind msg o !kick MWebKick
bind msg o !k MWebKick
proc MWebKick {nick uhost handle text} {WebKick $nick $uhost $handle [lindex $text 0] [lrange $text 1 end]}

### kick from IRC
bind pub o !kick WebKick
bind pub o !k WebKick
proc WebKick {nick uhost handle channel text} {
    global Pchannel Pchat
    set WGK [lindex $text 0]
    set REA [lrange $text 1 end]
    set JFound [lindex [verifkb $WGK $channel] 0]
    if { $JFound != ""} {
	dccputchan $Pchat([string tolower $channel]) "WCK $WGK $nick : $REA"
	putserv "PRIVMSG $channel : *** $nick Kicked $text"
    } else {
	putserv "PRIVMSG $nick : I don't know [lindex $text 0] on $channel, be sure that you typed '!k lamer(web)' to kick lamer"
    }
}

### ban from a msg
bind msg o !ban MWebBan
proc MWebBan {nick uhost handle text} {WebBan $nick $uhost $handle [lindex $text 0] [lrange $text 1 end]}

### ban from IRC
bind pub o !ban WebBan
proc WebBan {nick uhost handle channel text} {
    global Pchannel Pchat
    set WGK [lindex $text 0]
    set JFound [verifkb $WGK $channel]
    if { $JFound != ""} {
	putlog "$JFound"
	putserv "PRIVMSG $channel : *** $nick : *![lindex $JFound 2] +webban "
	dccputchan $Pchat([string tolower $channel]) "SAY *** $nick banned $WGK"
	dccputchan $Pchat([string tolower $channel]) "WCK $WGK $nick : banned!"
	putlog "*![lindex $JFound 2]  placed on ignore by $nick"
	newignore "*![lindex $JFound 2]" $handle "web ban" 10
	putserv "PRIVMSG $nick : $WGK is ignored for 10 minutes. If you want to permanently ignore him refer to eggdrops documentation about ignores"
    }   else {
	putserv "PRIVMSG $nick : I don't know [lindex $text 0] on $channel, be sure that you typed '!ban lamer(web)' to ban lamer"
    }
}

### unban from msg
bind msg o !uban MWebUBan
proc MWebUBan {nick uhost handle text} {WebUBan $nick $uhost $handle QWERTY $text}

### unban from IRC
bind pub o !uban WebUBan
proc WebUBan {nick uhost handle channel text} {
    if { [killignore $text] } {
	putlog "$text isn't ignored anymore"
	putserv "PRIVMSG $nick : $text isn't ignored anymore"
    } else {
	putserv "PRIVMSG $nick : $text isn't ignored, the command is !uban <host> , use !banlist to see what hosts are ignored"
    }
}

### return the ban list from a msg
bind msg o !banlist MWebLBan
proc MWebLBan {nick uhost handle text} {WebLBan $nick $uhost $handle QWERTY $text}

### return the ban list from a channel
bind pub o !banlist WebLBan
proc WebLBan {nick uhost handle channel text} {
    set tmp ""
    foreach ignore [ignorelist] {
	set tmp "$tmp ; [lindex $ignore 0]"
    }
    if {$tmp != ""} {
	putserv "PRIVMSG $nick : BANLIST: $tmp"
    } else {
	putserv "PRIVMSG $nick : no ignores"
    }
}


### the topic change on a channel
bind topc - * ctopc
proc ctopc { nick uhost handle channel topic} {
    global Pchannel DTopic Pchat
    dccputchan $Pchat([string tolower $channel]) "TOP $channel : $topic ."
    set DTopic($Pchat([string tolower $channel])) $topic
}

proc nuli {channel} {
    global Pchannel Pchat
    dccputchan $Pchat([string tolower $channel]) "ULI [chanlist $channel] [wulist 0 $Pchat([string tolower $channel])]"
}



### web user msg someone
bind dcc - wmsg cwmsg
proc cwmsg {handle idx arg} {
    global Pchannel Uidx
    set chnum [lindex $arg 0]
    set mynick [lindex $arg 1]
    set onick [lindex $arg 2]
    set text [lrange $arg 3 end]
    set infos [verifkb [lindex $arg 2] $Pchannel($chnum) ] 
    if { $infos != "" } {
	putdcc [lindex $infos 3] "*** SAY . *msg from $mynick* $text"
	putdcc $idx "*** SAY . *msg to $onick* $text"
    } else {
	if {[onchan $onick $Pchannel($chnum)] } {
	    putdcc $idx "*** SAY . *msg to $onick* $text"
	    putserv "PRIVMSG $onick : *don't reply to this* < $mynick > $text"
	} else {
	    putdcc $idx "*** SAY - *ERROR* I don't know $onick"
	}
    }
}


### handles web-joins
### arg = <#chat> <nick>(web) 
bind dcc - wjoin web_join
proc web_join {handle idx arg} {
    global Uidx Pchannel DTopic 
    set dccl [dcclist]
    set InetA ""
    set uNick [lindex $arg 1]
    set chnum [lindex $arg 0]
    foreach dcca $dccl {
	if {[lindex $dcca 0] == $idx } {
	    set InetA [lindex $dcca 2]
	}
    }
    if {$handle == "www" } {
	set Uidx($idx)  "$chnum $uNick $InetA"
	putserv "PRIVMSG $Pchannel($chnum) : *** $uNick $InetA joined"
	dccputchan $chnum "JOI $uNick $InetA"
    }
    putdcc $idx "*** TOP $Pchannel($chnum) : $DTopic($chnum) ."
}

### gives the userlist from IRC
bind pub - !who Cwww 
proc Cwww {nick uhost handle channel text} {
    global Pchannel URLJ Pchat
    putserv "PRIVMSG $nick : $URLJ($Pchat([string tolower $channel]))"
    putserv "PRIVMSG $nick : Users on the JeggLink:"
    foreach arg [wulist 1 $Pchat([string tolower $channel])] {
	putserv "PRIVMSG $nick : $arg"
    }
    putserv "PRIVMSG $nick : End of !who"
}


### create the userlist
proc wulist { wul chnum} {
    global Uidx
    set dccli [dcclist]
    set tmp ""
    foreach arg $dccli {
	if { [lindex $arg 1] == "www"} {
	    set uidxc [lindex $arg 0]
	    if { $Uidx($uidxc) != "" } {
		if { $wul == 0 } {
		    set Uidu [lindex $Uidx($uidxc) 1]
		} else {
		    set Uidu "[lindex $Uidx($uidxc) 1]:[lindex $Uidx($uidxc) 2]"
		}
		set tmp "$tmp $Uidu"
	    } 
	}
    }
    return $tmp
}

## to do
### a web user leave
bind chof - * chatoff
proc chatoff {handle idx } {
    global Uidx Pchannel
    if {$handle == "www" } {
	set Upart [lrange $Uidx($idx) 1 end]
	set chnum [lindex $Uidx($idx) 0]
	set Uidx($idx) ""
	putserv "PRIVMSG $Pchannel($chnum) : *** $Upart has left"
	dccputchan $chnum "PAR $Upart"
    }
}


### web-user changes his nick
### arg = <#chat> <nick>(web) 
bind dcc - wcnic w_cnic
proc w_cnic {handle idx arg} {
    global Uidx Pchannel
    set uNick [lindex $arg 1]
    set chan [lindex $arg 0]
    if {$handle == "www" } {
	set Uchan [lindex $Uidx($idx) 0]
	set Onick [lindex $Uidx($idx) 1]
	set InetA [lindex $Uidx($idx) 2]
	set Uidx($idx) "$Uchan $uNick $InetA"
	putserv "PRIVMSG $Pchannel($chan) : *** $Onick changed his nick to : $uNick"
	dccputchan $chan "NIC $Onick $uNick"
    }
}

### a web-users asked for a whois on someone
bind dcc - wwhois w_whois
proc w_whois {handle idx arg} {   
    global Uidx Pchannel
    set chnum [lindex $arg 0]
    set nick [lindex $arg 1]
    set web ""
    foreach wuser [wulist 1 $chnum] {
	set wwuser [lindex [split $wuser ":"] 0]
	if {$wwuser == $nick} {
	    putdcc $idx "*** SAY - $wwuser : [lindex [split $wuser ":"] 1]"
	    set web "ZOB"
	}
    }
    if {$web == ""} {
	set wisop ""
	if {[isop $nick $Pchannel($chnum)]} {
	    set wisop " (is an op)"
	}
	putdcc $idx "*** SAY - $nick : [getchanhost $nick $Pchannel($chnum)] $wisop"
    }
}



### test if a user can be kick - banned...
proc verifkb {WGK channel} {
    global Uidx Pchannel
    set JFound ""
    foreach arg [dcclist] {
	if {[lindex $arg 1] == "www"} {  
	    set uidxc [lindex $arg 0] 
	    if { ($WGK == [lindex $Uidx($uidxc) 1]) } {
		if {[string tolower $channel] == $Pchannel([lindex $Uidx($uidxc) 0])} {
		    set JFound "$Uidx($uidxc) $uidxc"
		}
	    }
	}
    }
    return $JFound   
}

### a web users asks for the userlist
### arg = <#chat>
bind dcc - ulist user_list
proc user_list {handle idx arg} {
    global Pchannel Uidx     
    putdcc $idx "*** ULI [chanlist $Pchannel($arg)] [wulist 0 $arg]"
}


#################

putlog "JeggLink v1.3 loaded \n please note that this script only works with eggdrop 1.3 \n and as been tested with eggdrop 1.3.14"














